/*
** tutor11.prg
*/

new;
library PDE2D,pgraph;
PDE2Dset;

#include elliptic.inc;

rndseed 123;

call PDE2D(&aProc,&bProc,&cProc,&dProc,&eProc,&fProc,&gProc,0,
           &InitialGuessSolution,
           &xminBound,&xmaxBound,&yminBound,&ymaxBound,
           0,0,0,0);

xmin = 0; xmax = 1; Nx = 21;
ymin = 0; ymax = 1; Ny = 21;
tmin = 0; tmax = 0.425; Nt = 101;

_Hopscotch_Methods = {2,3}; /* center filling method
                                      &
                               line Hopscotch method */

call Hopscotch(tmin,tmax,Nt,xmin,xmax,Nx,ymin,ymax,Ny,"tutor11");

x = ExtractSolution("tutor11","x");
y = ExtractSolution("tutor11","y");
t = ExtractSolution("tutor11","t");

sol = solutionProc(tmax,x,y);


graphset;

  begwind;
  window(4,4,0);

  _pdate = ""; _pnum = 0; _paxes = 0; _pframe = 0; _psurf = {0,0};
  _ptitlht = 0.45;    

  i = 1;
  do until i > 14;

    U = ExtractSolution("tutor11","t"|t[3*i]);

    setwind(i);
      str = ftos(3*i - 1,"iter no %lf",1,0);
      title(str);
      surface(x',y',U');

    i = i + 1;
  endo;

  U = ExtractSolution("tutor11","t"|t[Nt]);
 
  setwind(15);
    str = ftos(Nt,"iter no %lf",1,0);
    title(str);
    surface(x',y',U');

  setwind(16);
    title("Exact solution")
    surface(x',y',sol');

  graphprt("-c=1 -cf=tutor11.eps");

  endwind;
